# $Id: lib.cgi 96 2004-03-12 12:25:28Z mu $
# JX^}CYɕ֗Ȋ֐Q
# SOLD OUT  auto fBNgɃRs[ĂB
# łǂłg悤ɂȂ܂B
# package  main ɂȂ̂ŁAӂB

# usage : LibMin($a,$b) $a$brďԂ
sub LibMin{return $_[0]<$_[1] ? $_[0] : $_[1]}

# usage : LibMax($a,$b) $a$brđ傫Ԃ
sub LibMax{return $_[0]>$_[1] ? $_[0] : $_[1]}

# usage : LibSwap(\$a,\$b) $a$b
sub LibSwap{my $tmp=${$_[0]}; ${$_[0]}=${$_[1]}; ${$_[1]}=$tmp; return}

sub LibGetCount
{
	# usage: LibGetCount($count)
	#
	# ex: LibGetCount(100);    # 100
	#     LibGetCount(12.3);   # 12 or 13
	#     LibGetCount(-12.3);  # -12 or -13
	#     LibGetCount(0);      # 0
	#
	# mtJEg
	# mgď𐮐ɕϊ (3.1Ȃ1/10̊m4ɕϊ)
	#
	# $count : ܂ސ
	# ߂l : 
	my($val)=@_;
	my $int=int $val;
	$val>0 ? ($int++) : ($int--) if $val!=$int and rand 1<abs($val-$int);
	return $int;
}

sub LibEditData
{
	# usage: LibEditData($ref,$val[,{[min=>$min,][max=>$max,][set=>1,][float=>1,][abs=>1,]}])
	#
	# ex: $data=100;
	#     LibEditData(\$data,123);             # $data+=123;              (߂l  123)       # $data == 223
	#     LibEditData(\$data,-123);            # $data-=123;              (߂l -123)       # $data == 100
	#     LibEditData(\$data,123,{max=>200});  # $data+=100;              (߂l  100)       # $data == 200
	#     LibEditData(\$data,12.3);            # $data+=12; or $data+=13; (߂l 12 or 13)   # $data == 112 or 113
	#     LibEditData(\$data,123,{set=>1});    # $data=123;               (߂l 123)        # $data == 123
	#     LibEditData(\$data,-23.45,{abs=>1}); # $data-=23 or 24          (߂l 23 or 24)   # $data == 100 or 99
	#     LibEditData(\$data,"string!!");      # $data="string!!"         (߂l "string!!") # $data eq "string!!"
	#
	# ␳tf[^ύXoru֐
	# ݂̒l𑝌AKvł΍ŏlől̃`FbN&␳s܂B
	# l + - .(R})ȊO̒l܂܂ĂꍇAIvVŎw肳ꂽꍇ͒u܂B
	#
	# $ref   : Ώەϐ̃t@X (\$data X)
	# $val   : l or 
	# min    : option ŏl (ȗ͍ŏw薳)
	# max    : option ől (ȗ͍őw薳)
	# float  : option F߂ (̃IvVȂꍇ͏LibGetCountŕ␳)
	# set    : option ł͂Ȃ$valɒu (ł͕K{̃IvV)
	# abs    : option ߂l̑lΒl
	# ߂l : ۂɑłl or ݒ̒l
	#        : $ref ɕϐ̃t@X^Ȃꍇ undef
	my($ref,$val,$option)=@_;
	return undef if ref $ref ne "SCALAR";
	
	return $$ref=$val if $val eq "" or $val=~/[^\d\-\+\.e]/;
	
	$val=LibGetCount($val) if !$option->{float};
	$val=$$ref+$val if !$option->{set};
	$val=LibMax($val,$option->{min}) if exists $option->{min};
	$val=LibMin($val,$option->{max}) if exists $option->{max};
	
	my $old=$$ref;
	$$ref=$val;
	return $option->{set} ? $val : ($option->{abs} ? abs($val-$old) : ($val-$old));
}

my %_Lib_minmax_table=(
	rank		=>	[100,10000],
	money		=>	[0,$main::MAX_MONEY],
	moneystock	=>	[0,$main::MAX_MONEY],
);

sub LibDTEdit
{
	# usage: LibDTEdit($dt,$key,$val[,{option}])
	#
	# ex: LibDTEdit($dt,'money',12345,{set=>1}); # $dt->{money}=12345;  (߂l  12345) # 12345
	#     LibDTEdit($dt,'money',12345);          # $dt->{money}+=12345; (߂l  12345) # +12345
	#     LibDTEdit($dt,'money',-50000);         # $dt->{money}-=24690; (߂l -24690) # -50000(Ȃ̂0ɕ␳)
	#     IvV LibEditData Ɠ
	#
	# ␳t$DTf[^Zbg(␳Xg%_Lib_minmax_table)
	# $dt  : $DT([Uf[^nbV)
	# $key : f[^̃L[
	# $val : LibEditDataƓ
	# ߂l : LibEditDataƓ
	my($dt,$key,$val,$option)=@_;
	return undef if !$dt or !$key;
	
	if($_Lib_minmax_table{$key})
	{
		$option||={};
		$option->{min}=$_Lib_minmax_table{$key}[0] if !exists $option->{min};
		$option->{max}=$_Lib_minmax_table{$key}[1] if !exists $option->{max};
	}
	$dt->{$key}=0 if !exists $dt->{$key};
	return defined $val ? LibEditData(\$dt->{$key},$val,$option) : $dt->{$key};
}

sub LibDTItem
{
	# usage: LibDTItem($dt,$itemno[,$val[,{option}]])
	#
	# ex: LibDTItem($dt,10,123,{set=>1}); # $dt->{item}[10-1] =123; (߂l  123) # ACeNo10123
	#     LibDTItem($dt,10,123);          # $dt->{item}[10-1]+=123; (߂l  123) # ACeNo10+123(݌ɏ`FbN)
	#     LibDTItem($dt,10,-500);         # $dt->{item}[10-1]-=246; (߂l -246) # ACeNo10-500(Ȃ̂0ɕ␳)
	#     IvV LibEditData Ɠ
	#
	# ␳tACe擾ororu
	# $dt     : $DT([Uf[^nbV)
	# $itemno : iԍ(1`)
	# $val    : LibEditDataƓ ȗ݂͌̏擾
	# ߂l  : LibEditDataƓ
	#         : $valȗ݂͌̒l擾
	my($dt,$itemno,$val,$option)=@_;
	return 0 if $itemno<=0 || $itemno>$main::MAX_ITEM;
	$option||={};
	$option->{min}=0                           if !exists $option->{min};
	$option->{max}=$main::ITEM[$itemno]{limit} if !exists $option->{max};;
	return !defined $val ? ($dt->{item}[$itemno-1]||0) : LibEditData(\$dt->{item}[$itemno-1],$val,$option);
}

sub LibDTExp
{
	# usage: LibDTExp($dt,$itemno[,$val[,{option}]])
	#
	# ex: LibDTItem Ɠ
	#
	# ␳tnx擾ororu
	# $dt     : $DT([Uf[^nbV)
	# $itemno : iԍ(1`)
	# $val    : LibEditDataƓ ȗ݂͌̏nx擾
	# ߂l  : LibEditDataƓ
	#         : $valȗ݂͌̒l擾
	my($dt,$itemno,$val,$option)=@_;
	return 0 if $itemno<=0 || $itemno>$main::MAX_ITEM;
	$option||={};
	$option->{min}=0    if !exists $option->{min};
	$option->{max}=1000 if !exists $option->{max};;
	return !defined $val ? ($dt->{exp}{$itemno}||0) : LibEditData(\$dt->{exp}{$itemno},$val,$option);
}

sub LibDTUser
{
	# usage: LibDTUser($dt,$key[,$val[,{option}]])
	#
	# ex: LibDTUser($dt,'dust',123,{set=>1}); # $dt->{user}{dust} =123;   (߂l  123) # Ǝf[^ dust 123
	#     LibDTUser($dt,'dust',123);          # $dt->{user}{dust}+=123;   (߂l  123) # Ǝf[^ dust +123(`FbNȂ)
	#     LibDTUser($dt,'dust',-500);         # $dt->{user}{dust}-=500;   (߂l -500) # Ǝf[^ dust -500(`FbNȂ)
	#     LibDTUser($dt,'dust',"");           # delete $dt->{user}{dust}; (߂l   "") # Ǝf[^ dust 폜
	#     IvV LibEditData Ɠ
	#
	# $DT->{user}Ǝf[^̎擾ororu
	# $dt  : $DT([Uf[^nbV)
	# $key : [Uf[^̓ƎL[
	# $val : LibEditDataƓ ȗ݂͌̒l擾
	# option : LibEditDataƓ
	# ߂l : LibEditDataƓ
	#        : $valȗ݂͌̒l擾
	my($dt,$key,$val,$option)=@_;
	
	my $user_val=main::GetUserDataEx($dt,$key);
	return $user_val if !defined $val;
	
	my $result=LibEditData(\$user_val,$val,$option);
	main::SetUserDataEx($dt,$key,$user_val);
	return $result;
}

sub LibDTEditMoney
{
	# usage: LibDTEditMoney($dt,$val[,{option}])
	#
	# ␳t $DT->{money} & $DT->{moneystock} 
	# $DT->{money}𑝌Aő($MAX_MONEY)orŏ(0)𒴂ꍇɎc̑ $DT->{monetstock} ɍs܂B
	# IvVwŁAumoneystock Dvuőŏ𒴂Ă moneystock 𑝌ȂvAł܂B
	#
	# $dt  : $DT([Uf[^nbV)
	# $val : LibEditDataƓ
	# dem_money : option money()Dōs܂B(ftHg)
	# dem_stock : option moneystock()Dōs܂B
	# dem_only  : option ̌ʍőŏ𒴂Ă(money/moneystock)𑝌܂B
	# ߂l : LibEditDataƓ
	my($dt,$val,$option)=@_;
	
	$option||={};
	my $target1="money";
	my $target2="moneystock";
	my $abs=exists $option->{abs};
	my $val_orig=$val;
	
	LibSwap(\$target1,\$target2) if exists $option->{dem_stock};
	delete $option->{abs} if $abs;
	
	my $result=LibDTEdit($dt,$target1,$val,$option);
	if(!exists $option->{set} && !exists $option->{dem_only} && $result!=$val)
	{
		my $result2=LibDTEdit($dt,$target2,$val-$result,$option);
		$result+=$result2;
	}
	$option->{abs}=1 if $abs;
	
	return $abs ? abs($result) : $result;
}

sub LibDTEditTime
{
	# usage: LibDTEditMoney($dt,$val[,{option}])
	#
	# ␳t $DT->{time} 
	# $DT->{time} 𑝌AԂ̑s܂B
	# ő厝($MAX_STOCK_TIME)vZɓ܂B
	#
	# $dt  : $DT([Uf[^nbV)
	# $val : LibEditDataƓ
	# ߂l : LibEditDataƓ
	my($dt,$val,$option)=@_;
	
	LibDTEdit($dt,'time',0,{min=>$main::NOW_TIME-$main::MAX_STOCK_TIME}); # ԂőԂɕ␳
	return -LibDTEdit($dt,'time',-$val,{min=>$main::NOW_TIME-$main::MAX_STOCK_TIME});
}

sub LibDTItemList
{
	# usage: LibDTItemList($dt,[,{option}])
	#
	# $DTLiXg擾
	# Ă鏤iԍXg̃t@XԂ܂B
	#
	# $dt  : $DT([Uf[^nbV)
	# ߂l : [iԍ1,iԍ2,iԍ3,...]
	#        : ȂɂĂȂꍇ͋󃊃Xg
	my($dt,$option)=@_;
	$option||={};
	my @itemlist=grep $dt->{item}[$_-1],(1..$main::MAX_ITEM);
	@itemlist=sort{$main::ITEM[$a]->{sort}<=>$main::ITEM[$b]->{sort}} @itemlist if $option->{sort};
	return scalar @itemlist ? \@itemlist : ();
}

sub LibItemCode2No
{
	# usage: LibItemCode2No($item_code)
	#
	# iR[hԍɕϊ
	# 
	# $code  : iR[h($ITEM[?]->{code})
	# ߂l : R[hɑΉ鏤iԍ
	#        : ݂Ȃił 0
	my($code)=@_;
	foreach my $no (1..$main::MAX_ITEM)
	{
		return $no if $main::ITEM[$no]{code} eq $code;
	}
	return 0;
}

sub LibDT{return $_[0]->{$_[1]}||""}                # LibDT($DT,$key)       $DT->{$key}擾
sub LibItem{return $main::ITEM[$_[0]]->{$_[1]}||""} # LibItem($itemno,$key) $ITEM[$itemno]->{$key} 擾

sub LibShopname{return LibDT($_[0],'shopname')} # LibShopname($DT)      $DTt@XXܖ擾
sub LibItemName{return LibItem($_[0],'name')}   # LibItemName($itemno)  iԍ疼̂擾
sub LibItemScale{return LibItem($_[0],'scale')} # LibItemScale($itemno) iԍ琔Pʂ擾

1;
